// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

#ifndef CALL_QUEUE_H
#define CALL_QUEUE_H

#include <IceUtil/Thread.h>
#include <IceUtil/Monitor.h>
#include <IceUtil/Mutex.h>
#include <IceUtil/Handle.h>
#include <IceUtil/Shared.h>
#include <Ice/Exception.h>

#include <list>
#include <memory>

class CallQueue;
typedef IceUtil::Handle<CallQueue> CallQueuePtr;

class Call : public IceUtil::Shared
{
public:

    virtual void execute(const CallQueuePtr&) = 0;
};
typedef IceUtil::Handle<Call> CallPtr;

class CallQueue : public IceUtil::Thread, public IceUtil::Monitor<IceUtil::Mutex>
{
public:

    CallQueue();

    void add(const CallPtr&);
    void destroy();
    virtual void run();

    void error(const Ice::Exception&);

private:

    std::list<CallPtr> _req;
    bool _destroy;
    std::auto_ptr<Ice::Exception> _exception;
};

#endif
