// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

#include <Ice/Ice.h>
#include <HelloI.h>

using namespace std;


class ICECallable: public Call
{
public:
	ICECallable(const Demo::AMD_Hello_sayHelloPtr& callback):callback(callback){}
	virtual void execute(const CallQueuePtr&)
	{
		cout<<"Sending AMD response "<<this<<endl;
		callback->ice_response();
	}

private:
	Demo::AMD_Hello_sayHelloPtr callback;
};

void
HelloI::sayHello(const Ice::Current&)
{
    cout << "Hello World!" << endl;
    sleep(1);
}

void HelloI::sayHello_async(const Demo::AMD_Hello_sayHelloPtr& _cb, const Ice::Current&)
{
    cout << "Hello World async! "<< _cb<< endl;

    queue->add(CallPtr(new ICECallable(_cb)));
}
